Package org.eclipse.cdt.core.dom.ast.cpp

## Interface ICPPASTLiteralExpression

All Superinterfaces:
  `IASTExpression`, `IASTImplicitDestructorNameOwner`, `IASTImplicitNameOwner`, `IASTInitializerClause`, `IASTLiteralExpression`, `IASTNode`, `ICPPASTExpression`, `ICPPASTInitializerClause`

    public interface ICPPASTLiteralExpression
    extends IASTLiteralExpression, ICPPASTExpression, IASTImplicitNameOwner

C++ adds additional literal types to primary expression.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`IASTExpression.ValueCategory`

### Nested classes/interfaces inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`IASTNode.CopyStyle`

### Field Summary

Fields
`static int` `lk_false` `lk_false` represents the 'false' keyword.
`static int` `lk_last` Deprecated. All constants must be defined in `IASTLiteralExpression`.
`static int` `lk_this` `lk_this` represents the 'this' keyword.
`static int` `lk_true` `lk_true` represents the 'true' keyword.

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`EMPTY_EXPRESSION_ARRAY`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`IMPLICIT_DESTRUCTOR_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`IMPLICIT_NAME`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTLiteralExpression

`lk_char_constant, lk_float_constant, lk_integer_constant, lk_nullptr, lk_string_literal`

### Fields inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`EMPTY_NODE_ARRAY`

### Method Summary

All Methods Instance Methods Abstract Methods
`ICPPASTLiteralExpression` `copy()` Returns a mutable copy of the tree rooted at this node.
`ICPPASTLiteralExpression` `copy​(IASTNode.CopyStyle style)` Returns a mutable copy of the tree rooted at this node.

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTExpression

`getExpressionType, getValueCategory, isLValue`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitDestructorNameOwner

`getImplicitDestructorNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTImplicitNameOwner

`getImplicitNames`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTLiteralExpression

`getKind, getValue, setKind, setValue, setValue, toString`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.IASTNode

`accept, contains, getChildren, getContainingFilename, getFileLocation, getLeadingSyntax, getNodeLocations, getOriginalNode, getParent, getPropertyInParent, getRawSignature, getSyntax, getTrailingSyntax, getTranslationUnit, isActive, isFrozen, isPartOfTranslationUnitFile, setParent, setPropertyInParent`

### Methods inherited from interface org.eclipse.cdt.core.dom.ast.cpp.ICPPASTInitializerClause

`getEvaluation`

### Field Detail

#### lk_this

    static final int lk_this

`lk_this` represents the 'this' keyword.

See Also:
  Constant Field Values

#### lk_true

    static final int lk_true

`lk_true` represents the 'true' keyword.

See Also:
  Constant Field Values

#### lk_false

    static final int lk_false

`lk_false` represents the 'false' keyword.

See Also:
  Constant Field Values

#### lk_last

    @Deprecated
    static final int lk_last

Deprecated.
All constants must be defined in `IASTLiteralExpression`.

See Also:
  Constant Field Values
Restriction:
  This field is not intended to be referenced by clients.

### Method Detail

#### copy

    ICPPASTLiteralExpression copy()

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Calling this method is equivalent to `copy(CopyStyle.withoutLocations)`.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTLiteralExpression`
Specified by:
  `copy` in interface `IASTNode`
Since:
  5.1

#### copy

    ICPPASTLiteralExpression copy​(IASTNode.CopyStyle style)

Description copied from interface: `IASTNode`
Returns a mutable copy of the tree rooted at this node. The following postconditions hold:

     copy.getParent() == null
     copy.getPropertyInParent() == null
     copy.isFrozen() == false

Preprocessor nodes do not currently support being copied. Implicit name nodes are not copied, instead they can be regenerated if required.

Specified by:
  `copy` in interface `IASTExpression`
Specified by:
  `copy` in interface `IASTInitializerClause`
Specified by:
  `copy` in interface `IASTLiteralExpression`
Specified by:
  `copy` in interface `IASTNode`
Parameters:
  `style` - `IASTNode.CopyStyle` create a copy with or without locations. Please see `IASTNode.CopyStyle` for restrictions on copies with Locations.
Since:
  5.3